Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/test/java/org/gvsig/fmap/dal/store/jdbc2/ExpressionBuilderTest.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/test/java/org/gvsig/fmap/dal/store/jdbc2/ExpressionBuilderTest.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/test/java/org/gvsig/fmap/dal/store/jdbc2/ExpressionBuilderTest.java	(revision 43114)
@@ -0,0 +1,209 @@
+package org.gvsig.fmap.dal.store.jdbc2;
+
+import java.util.ArrayList;
+import java.util.List;
+import org.apache.commons.lang3.ArrayUtils;
+import org.cresques.cts.IProjection;
+import org.gvsig.fmap.crs.CRSFactory;
+import org.gvsig.fmap.dal.ExpressionBuilder;
+import org.gvsig.fmap.dal.ExpressionBuilder.Config;
+import org.gvsig.fmap.dal.ExpressionBuilder.GeometrySupportType;
+import org.gvsig.fmap.dal.ExpressionBuilder.Parameter;
+import static org.gvsig.fmap.dal.ExpressionBuilder.ParameterType.Constant;
+import org.gvsig.fmap.dal.ExpressionBuilder.Variable;
+import org.gvsig.fmap.dal.feature.spi.ExpressionBuilderBase;
+import org.gvsig.fmap.geom.Geometry;
+import org.gvsig.fmap.geom.GeometryLocator;
+import org.gvsig.fmap.geom.GeometryManager;
+import org.gvsig.fmap.geom.exception.CreateGeometryException;
+import org.gvsig.fmap.geom.primitive.Point;
+import org.gvsig.tools.junit.AbstractLibraryAutoInitTestCase;
+
+public class ExpressionBuilderTest extends AbstractLibraryAutoInitTestCase {
+    
+    @Override
+    protected void doSetUp() throws Exception {
+
+    }
+    
+    List<String> getVariableNames(ExpressionBuilder builder) {
+        List<String> vars = new ArrayList<>();
+        for (Variable var : builder.getVariables()) {
+            vars.add(var.getName());
+        }
+        return vars;
+    }
+    
+    List<String> getParameterNames(ExpressionBuilder builder) {
+        List<String> params = new ArrayList<>();
+        for (Parameter param : builder.getParameters()) {
+            String s;
+            switch(param.getType()) {
+                case Constant:
+                    Object value = param.getValue();
+                    if( value==null ) {
+                        s = "null";
+                    } else if( value instanceof String ) {
+                        s = "'" + (String)value + "'";
+                    } else {
+                        s = value.toString();
+                    }    
+                    break;
+                case Geometry:
+                case Variable:
+                default:
+                    s = "\"" + param.getName() + "\"";
+            }
+            params.add(s);
+        }
+        return params;
+    }
+    
+    public void test2() {
+        ExpressionBuilder builder = new ExpressionBuilderBase();
+        
+        builder.and(
+          builder.eq(
+            builder.lcase(builder.variable("colum_name_c")),
+            builder.parameter("colum_name_p")
+          )
+        );
+        builder.and(
+            builder.group(
+                builder.or(
+                    builder.like(
+                        builder.lcase( builder.variable("uno")),
+                        builder.constant("%10")
+                    ),
+                    builder.lt(
+                        builder.variable("dos"),
+                        builder.constant(-3.5)
+                    )
+                )
+            )
+        );
+        builder.and(
+                builder.ST_Intersects(
+                    builder.variable("geom1"), 
+                    builder.ST_Envelope(
+                        builder.ST_GeomFromWKB(
+                                builder.parameter("geom2"), 
+                                builder.parameter().value(4326).as_constant()
+                        )
+                    )
+                )
+        );
+        builder.and(
+            builder.gt(
+                builder.variable("tres"),
+                builder.constant(123456789)
+            )
+        );
+        assertEquals(
+                "( (LCASE(\"colum_name_c\")) = (?) ) AND ( ( (LCASE(\"uno\")) LIKE ('%10') ) OR ( (\"dos\") < (-3.5) ) ) AND ST_Intersects((\"geom1\"), (ST_Envelope(ST_GeomFromWKB((?), (?))))) AND ( (\"tres\") > (123456789) )",
+                builder.toString()
+        );
+        assertEquals(
+                "[colum_name_c, dos, geom1, tres, uno]",
+                ArrayUtils.toString(getVariableNames(builder))
+        );
+        assertEquals(
+                "[\"colum_name_p\", \"geom2\", 4326]",
+                ArrayUtils.toString(getParameterNames(builder))
+        );
+    }
+    
+    public void test3() throws CreateGeometryException {
+        ExpressionBuilder builder = new ExpressionBuilderBase();
+                
+        GeometryManager geometryManager = GeometryLocator.getGeometryManager();
+        IProjection proj = CRSFactory.getCRS("EPSG:4326");
+        
+        Point point = geometryManager.createPoint(10, 20, Geometry.SUBTYPES.GEOM2D);
+        builder.set(        
+            builder.ST_Intersects(
+              builder.geometry(point,proj),
+              builder.variable("the_geom")
+            )
+        );
+        builder.getConfig().set(Config.geometry_type_support, GeometrySupportType.WKT);
+        System.out.println(builder.toString());
+        assertEquals(
+                "ST_Intersects((ST_GeomFromText('POINT (10 20)', (4326))), (\"the_geom\"))",
+                builder.toString()
+        );
+        builder.getConfig().set(Config.geometry_type_support, GeometrySupportType.WKB);
+        System.out.println(builder.toString());
+        assertEquals(
+                "ST_Intersects((ST_GeomFromWKB((0x000000000140240000000000004034000000000000), (4326))), (\"the_geom\"))",
+                builder.toString()
+        );
+        assertEquals(
+                "[the_geom]",
+                ArrayUtils.toString(getVariableNames(builder))
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(getParameterNames(builder))
+        );
+    }
+    
+    public void test4() throws CreateGeometryException {
+        ExpressionBuilder builder = new ExpressionBuilderBase();
+                
+        IProjection proj = CRSFactory.getCRS("EPSG:4326");
+        
+        builder.and(
+                builder.ST_Intersects(
+                    builder.variable("geom1"), 
+                    builder.ST_Envelope(
+                        builder.ST_GeomFromWKB(
+                                builder.parameter("geom2"), 
+                                builder.parameter().value(proj).as_constant()
+                        )
+                    )
+                )
+        );
+        
+        System.out.println(builder.toString());
+        assertEquals(
+                "ST_Intersects((\"geom1\"), (ST_Envelope(ST_GeomFromWKB((?), (?)))))",
+                builder.toString()
+        );
+        assertEquals(
+                "[geom1]",
+                ArrayUtils.toString(getVariableNames(builder))
+        );
+        assertEquals(
+                "[\"geom2\", 4326]",
+                ArrayUtils.toString(getParameterNames(builder))
+        );
+    }
+        
+    public void test5() throws CreateGeometryException {
+        ExpressionBuilder builder = new ExpressionBuilderBase();
+                
+        IProjection proj = CRSFactory.getCRS("EPSG:4326");
+        
+        builder.and(
+                builder.eq(
+                        builder.ST_SRID( builder.variable("geom") ),
+                        builder.srs(proj)
+                )
+        );
+        
+        System.out.println(builder.toString());
+        assertEquals(
+                "( (ST_SRID(\"geom\")) = (4326) )",
+                builder.toString()
+        );
+        assertEquals(
+                "[geom]",
+                ArrayUtils.toString(getVariableNames(builder))
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(getParameterNames(builder))
+        );
+    }
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/test/java/org/gvsig/fmap/dal/store/jdbc2/SQLBuilderTest.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/test/java/org/gvsig/fmap/dal/store/jdbc2/SQLBuilderTest.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/test/java/org/gvsig/fmap/dal/store/jdbc2/SQLBuilderTest.java	(revision 43114)
@@ -0,0 +1,486 @@
+package org.gvsig.fmap.dal.store.jdbc2;
+
+import java.util.ArrayList;
+import java.util.List;
+import org.apache.commons.lang3.ArrayUtils;
+import org.cresques.cts.IProjection;
+import org.gvsig.fmap.crs.CRSFactory;
+import org.gvsig.fmap.dal.ExpressionBuilder;
+import org.gvsig.fmap.dal.ExpressionBuilder.Constant;
+import org.gvsig.fmap.dal.ExpressionBuilder.Parameter;
+import org.gvsig.fmap.dal.ExpressionBuilder.Variable;
+import org.gvsig.fmap.dal.SQLBuilder;
+import org.gvsig.fmap.dal.SQLBuilder.Privilege;
+import org.gvsig.fmap.dal.feature.spi.SQLBuilderBase;
+import org.gvsig.fmap.geom.DataTypes;
+import org.gvsig.fmap.geom.Geometry;
+import org.gvsig.fmap.geom.GeometryLocator;
+import org.gvsig.fmap.geom.GeometryManager;
+import org.gvsig.fmap.geom.primitive.Polygon;
+import org.gvsig.tools.junit.AbstractLibraryAutoInitTestCase;
+
+public class SQLBuilderTest extends AbstractLibraryAutoInitTestCase {
+    
+    @Override
+    protected void doSetUp() throws Exception {
+
+    }
+    
+    List<String> getVariableNames(ExpressionBuilder builder) {
+        List<String> vars = new ArrayList<>();
+        for (Variable var : builder.getVariables()) {
+            vars.add(var.getName());
+        }
+        return vars;
+    }
+    
+    List<String> getParameterNames(ExpressionBuilder builder) {
+        List<String> params = new ArrayList<>();
+        for (Parameter param : builder.getParameters()) {
+            String s;
+            switch(param.getType()) {
+                case Constant:
+                    Object value = param.getValue();
+                    if( value==null ) {
+                        s = "null";
+                    } else if( value instanceof String ) {
+                        s = "'" + (String)value + "'";
+                    } else {
+                        s = value.toString();
+                    }    
+                    break;
+                case Geometry:
+                case Variable:
+                default:
+                    s = "\"" + param.getName() + "\"";
+            }
+            params.add(s);
+        }
+        return params;
+    }
+    
+ 
+    public void testCalulateEnvelope() throws Exception {
+        GeometryManager geometryManager = GeometryLocator.getGeometryManager();
+        IProjection proj = CRSFactory.getCRS("EPSG:4326");
+        
+        Polygon limit = geometryManager.createPolygon(Geometry.SUBTYPES.GEOM2D);
+        limit.addVertex(0, 0);
+        limit.addVertex(0, 100);
+        limit.addVertex(100, 100);
+        limit.addVertex(100, 0);
+        limit.addVertex(0, 0);
+        
+        SQLBuilder builder = new SQLBuilderBase();
+        
+        builder.select().column().value(
+            builder.getAsGeometry(
+              builder.ST_ExtentAggregate(
+                builder.column("the_geom")
+              )
+            )
+        ).as("envelope");
+        builder.select().from().table().database("master").schema("dbo").name("test1");
+        builder.select().where().set(
+            builder.ST_Intersects(
+                builder.ST_Envelope(
+                    builder.column("the_geom")
+                ),
+                builder.geometry(limit, proj)
+            )
+        );
+        builder.select().where().and(
+                builder.custom("x = 27")
+        );
+        
+        // SELECT ST_AsBinary(ST_Extent("the_geom")) AS "envelope" FROM "master"."dbo"."test1" WHERE ST_Intersects((ST_Envelope("the_geom")), (ST_GeomFromText('POLYGON ((0 0, 0 100, 100 100, 100 0, 0 0))', (4326)))) AND x = 27
+        
+        System.out.println("# Test:: testCalulateEnvelope");
+        System.out.println("# SQL:: " + builder.toString());
+        System.out.println("# Variables:: " + ArrayUtils.toString(getVariableNames(builder)));
+        System.out.println("# Parametros:: " + ArrayUtils.toString(getParameterNames(builder)));
+        assertEquals(
+                "SELECT ST_AsBinary(ST_Extent(\"the_geom\")) AS \"envelope\" FROM \"master\".\"dbo\".\"test1\" WHERE ST_Intersects((ST_Envelope(\"the_geom\")), (ST_GeomFromText('POLYGON ((0 0, 0 100, 100 100, 100 0, 0 0))', (4326)))) AND x = 27",
+                builder.toString()
+        );
+        assertEquals(
+                "[the_geom]",
+                ArrayUtils.toString(getVariableNames(builder))
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(getParameterNames(builder))
+        );
+    }
+
+    public void testCount() throws Exception {
+        SQLBuilder builder = new SQLBuilderBase();
+        
+        builder.select().column().value(builder.count().all());
+        builder.select().from().table().database("master").schema("dbo").name("test1");
+        builder.select().from().subquery(null);
+        builder.select().where().set( builder.custom("pp = 200"));
+
+        System.out.println("# Test:: testCount");
+        System.out.println("# SQL:: " + builder.toString());
+        System.out.println("# Variables:: " + ArrayUtils.toString(getVariableNames(builder)));
+        System.out.println("# Parametros:: " + ArrayUtils.toString(getParameterNames(builder)));
+
+        //# Test:: testCount
+        //# SQL:: SELECT COUNT(*) FROM "master"."dbo"."test1" WHERE pp = 200
+        //# Variables:: []
+        //# Parametros:: []
+
+        assertEquals(
+                "SELECT COUNT(*) FROM \"master\".\"dbo\".\"test1\" WHERE pp = 200",
+                builder.toString()
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(getVariableNames(builder))
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(getParameterNames(builder))
+        );
+    }
+    
+    public void testCreateTable() throws Exception {
+        SQLBuilder builder = new SQLBuilderBase();
+
+        builder.create_table().table().database("master").schema("dbo").name("test1");
+        builder.create_table().add_column(
+                "name",
+                DataTypes.STRING,
+                45,
+                0,
+                false,
+                true,
+                false,
+                null
+        );
+        builder.create_table().add_column(
+                "id",
+                DataTypes.INT,
+                0,
+                0,
+                true,
+                false,
+                true,
+                0
+        );
+        builder.create_table().add_column(
+                "geom",
+                DataTypes.GEOMETRY,
+                0,
+                0,
+                false,
+                true,
+                false,
+                null
+        );
+
+        
+        // CREATE TABLE "master"."dbo"."test1" ("name" VARCHAR(45) DEFAULT NULL NULL, "id" SERIAL DEFAULT '0' NOT NULL PRIMARY KEY, "geom" TEXT DEFAULT NULL NULL )
+        System.out.println("# Test:: testCreateTable");
+        System.out.println("# SQL:: " + builder.toString());
+        System.out.println("# Variables:: " + ArrayUtils.toString(getVariableNames(builder)));
+        System.out.println("# Parametros:: " + ArrayUtils.toString(getParameterNames(builder)));
+        assertEquals(
+                "CREATE TABLE \"master\".\"dbo\".\"test1\" (\"name\" VARCHAR(45) DEFAULT NULL NULL, \"id\" SERIAL DEFAULT '0' NOT NULL PRIMARY KEY, \"geom\" TEXT DEFAULT NULL NULL )",
+                builder.toString()
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(getVariableNames(builder))
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(getParameterNames(builder))
+        );
+    }
+
+    public void testDropTable() throws Exception {
+        SQLBuilder builder = new SQLBuilderBase();
+        
+        builder.drop_table().table().database("master").schema("dbo").name("test1");
+
+        // DROP TABLE "master"."dbo"."test1"; DELETE FROM GEOMETRY_COLUMNS WHERE f_table_schema = 'dbo' AND f_table_name = 'test1'
+        
+        System.out.println("# Test:: testDropTable");
+        System.out.println("# SQL:: " + builder.toString());
+        System.out.println("# Variables:: " + ArrayUtils.toString(getVariableNames(builder)));
+        System.out.println("# Parametros:: " + ArrayUtils.toString(getParameterNames(builder)));
+        assertEquals(
+                "DROP TABLE \"master\".\"dbo\".\"test1\"; DELETE FROM GEOMETRY_COLUMNS WHERE f_table_schema = 'dbo' AND f_table_name = 'test1'",
+                builder.toString()
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(getVariableNames(builder))
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(getParameterNames(builder))
+        );
+    }
+    
+    public void testFetchFeatureProviderByReference() throws Exception {
+        SQLBuilder builder = new SQLBuilderBase();
+        
+        String value = "yoyo";
+        builder.select().column().name("name");
+        builder.select().column().name("id");
+        builder.select().column().name("geom").as_geometry();
+        builder.select().from().table().database("master").schema("dbo").name("test1");
+        builder.select().where().set(
+            builder.eq(
+                builder.column("name"),
+                builder.parameter(value).as_constant()
+            )
+        );
+        builder.select().limit(1);
+
+        // SELECT "name", "id", ST_AsBinary("geom") FROM "master"."dbo"."test1" WHERE ( ("name") = (?) ) LIMIT 1
+
+        System.out.println("# Test:: testFetchFeatureProviderByReference");
+        System.out.println("# SQL:: " + builder.toString());
+        System.out.println("# Variables:: " + ArrayUtils.toString(getVariableNames(builder)));
+        System.out.println("# Parametros:: " + ArrayUtils.toString(getParameterNames(builder)));
+        assertEquals(
+                "SELECT \"name\", \"id\", ST_AsBinary(\"geom\") FROM \"master\".\"dbo\".\"test1\" WHERE ( (\"name\") = (?) ) LIMIT 1",
+                builder.toString()
+        );
+        assertEquals(
+                "[geom, id, name]",
+                ArrayUtils.toString(getVariableNames(builder))
+        );
+        assertEquals(
+                "['yoyo']",
+                ArrayUtils.toString(getParameterNames(builder))
+        );
+    }
+    
+    public void testFetchFeatureType() throws Exception {
+        SQLBuilder builder = new SQLBuilderBase();
+
+        builder.select().column().all();
+        builder.select().from().table().database("master").schema("dbo").name("test1");
+        builder.select().limit(1);
+
+        System.out.println("# Test:: testFetchFeatureType");
+        System.out.println("# SQL:: " + builder.toString());
+        System.out.println("# Variables:: " + ArrayUtils.toString(getVariableNames(builder)));
+        System.out.println("# Parametros:: " + ArrayUtils.toString(getParameterNames(builder)));
+        
+        //# Test:: testFetchFeatureType
+        //# SQL:: SELECT * FROM [master].[dbo].[test1] LIMMIT 1
+        //# Variables:: []
+        //# Parametros:: []        
+        
+        assertEquals(
+                "SELECT * FROM \"master\".\"dbo\".\"test1\" LIMIT 1",
+                builder.toString()
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(getVariableNames(builder))
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(getParameterNames(builder))
+        );
+    }
+        
+    public void testPerformDeletes() throws Exception {
+        SQLBuilder builder = new SQLBuilderBase();
+
+        builder.delete().table().database("master").schema("dbo").name("test1");
+        builder.delete().where().and(
+            builder.eq( 
+                builder.column("id1"),
+                builder.parameter("id1").as_variable()
+            )
+        );
+        builder.delete().where().and(
+            builder.eq( 
+                builder.column("id2"),
+                builder.parameter("id2").as_variable()
+            )
+        );
+
+        // DELETE FROM "master"."dbo"."test1" WHERE ( ("id1") = (?) ) AND ( ("id2") = (?) )
+
+        System.out.println("# Test:: testPerformDeletes");
+        System.out.println("# SQL:: " + builder.toString());
+        System.out.println("# Variables:: " + ArrayUtils.toString(getVariableNames(builder)));
+        System.out.println("# Parametros:: " + ArrayUtils.toString(getParameterNames(builder)));
+        assertEquals(
+                "DELETE FROM \"master\".\"dbo\".\"test1\" WHERE ( (\"id1\") = (?) ) AND ( (\"id2\") = (?) )",
+                builder.toString()
+        );
+        assertEquals(
+                "[id1, id2]",
+                ArrayUtils.toString(getVariableNames(builder))
+        );
+        assertEquals(
+                "[\"id1\", \"id2\"]",
+                ArrayUtils.toString(getParameterNames(builder))
+        );
+    }
+
+    public void testPerformInserts1() throws Exception {
+        IProjection proj = CRSFactory.getCRS("EPSG:4326");
+
+        SQLBuilder builder = new SQLBuilderBase();
+
+        builder.insert().table().database("master").schema("dbo").name("test1");
+        builder.insert().column().name("id").with_value(builder.parameter("id"));
+        builder.insert().column().name("name").with_value(builder.parameter("name"));
+        builder.insert().column().name("geom").with_value(builder.parameter("geom").as_geometry_variable().srs(proj));
+        
+        // INSERT INTO "master"."dbo"."test1" ( "id", "name", "geom" ) VALUES ( ?, ?, ST_GeomFromText(?, (4326)) )
+        
+        System.out.println("# Test:: testPerformInserts1");
+        System.out.println("# SQL:: " + builder.toString());
+        System.out.println("# Variables:: " + ArrayUtils.toString(getVariableNames(builder)));
+        System.out.println("# Parametros:: " + ArrayUtils.toString(getParameterNames(builder)));
+        assertEquals(
+                "INSERT INTO \"master\".\"dbo\".\"test1\" ( \"id\", \"name\", \"geom\" ) VALUES ( ?, ?, ST_GeomFromText(?, (4326)) )",
+                builder.toString()
+        );
+        assertEquals(
+                "[geom, id, name]",
+                ArrayUtils.toString(getVariableNames(builder))
+        );
+        assertEquals(
+                "[\"id\", \"name\", \"geom\"]",
+                ArrayUtils.toString(getParameterNames(builder))
+        );
+    }
+
+    public void testPerformInserts2() throws Exception {
+        IProjection proj = CRSFactory.getCRS("EPSG:4326");
+
+        SQLBuilder builder = new SQLBuilderBase();
+
+        builder.insert().table().database("master").schema("dbo").name("test1");
+        builder.insert().column().name("id").with_value(builder.parameter("id"));
+        builder.insert().column().name("name").with_value(builder.parameter("name"));
+        builder.insert().column().name("geom").with_value(builder.parameter("geom").as_geometry_variable().srs(proj));
+        
+        // INSERT INTO "master"."dbo"."test1" ( "id", "name", "geom" ) VALUES ( ?, ?, ST_GeomFromText(?, (?)) )
+        
+        System.out.println("# Test:: testPerformInserts2");
+        System.out.println("# SQL:: " + builder.toString());
+        System.out.println("# Variables:: " + ArrayUtils.toString(getVariableNames(builder)));
+        System.out.println("# Parametros:: " + ArrayUtils.toString(getParameterNames(builder)));
+        assertEquals(
+                "INSERT INTO \"master\".\"dbo\".\"test1\" ( \"id\", \"name\", \"geom\" ) VALUES ( ?, ?, ST_GeomFromText(?, (?)) )",
+                builder.toString()
+        );
+        assertEquals(
+                "[geom, id, name]",
+                ArrayUtils.toString(getVariableNames(builder))
+        );
+        assertEquals(
+                "[\"id\", \"name\", \"geom\", 4326]",
+                ArrayUtils.toString(getParameterNames(builder))
+        );
+    }
+
+    public void testPerformUpdates() throws Exception {
+        IProjection proj = CRSFactory.getCRS("EPSG:4326");
+
+        SQLBuilder builder = new SQLBuilderBase();
+
+        builder.update().table().database("master").schema("dbo").name("test1");
+        builder.update().where().and(
+            builder.eq(
+                builder.column("id"), 
+                builder.parameter("id").as_variable()
+            )
+        );
+        builder.update().column().name("name").with_value(builder.parameter("name"));
+        builder.update().column().name("geom").with_value(
+                builder.parameter("geom").as_geometry_variable().srs(proj) 
+        );
+
+        // UPDATE "master"."dbo"."test1" SET "name" = ?, "geom" = ST_GeomFromText(?, (?)) WHERE ( ("id") = (?) )
+
+        System.out.println("# Test:: testPerformUpdates");
+        System.out.println("# SQL:: " + builder.toString());
+        System.out.println("# Variables:: " + ArrayUtils.toString(getVariableNames(builder)));
+        System.out.println("# Parametros:: " + ArrayUtils.toString(getParameterNames(builder)));
+        assertEquals(
+                "UPDATE \"master\".\"dbo\".\"test1\" SET \"name\" = ?, \"geom\" = ST_GeomFromText(?, (?)) WHERE ( (\"id\") = (?) )",
+                builder.toString()
+        );
+        assertEquals(
+                "[geom, id, name]",
+                ArrayUtils.toString(getVariableNames(builder))
+        );
+        assertEquals(
+                "[\"name\", \"geom\", 4326, \"id\"]",
+                ArrayUtils.toString(getParameterNames(builder))
+        );
+    }
+
+    public void testGrant1() throws Exception {
+
+        SQLBuilder builder = new SQLBuilderBase();
+
+        builder.grant().table().database("master").schema("dbo").name("test1");
+        builder.grant().role("prueba").select().insert().update();
+        builder.grant().role("gis").all();
+                
+        
+        System.out.println("# Test:: testGrant1");
+        System.out.println("# SQL:: " + builder.toString());
+        System.out.println("# Variables:: " + ArrayUtils.toString(getVariableNames(builder)));
+        System.out.println("# Parametros:: " + ArrayUtils.toString(getParameterNames(builder)));
+        assertEquals(
+                "",
+                builder.toString()
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(getVariableNames(builder))
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(getParameterNames(builder))
+        );
+    }
+
+    public void testGrant2() throws Exception {
+
+        SQLBuilder builder = new SQLBuilderBase();
+
+        builder.grant().table().database("master").schema("dbo").name("test1");
+        builder.grant().role("prueba").privilege(Privilege.SELECT)
+                .privilege(Privilege.INSERT)
+                .privilege(Privilege.UPDATE);
+        builder.grant().role("gis").privilege(Privilege.ALL);
+                
+        
+        System.out.println("# Test:: testGrant2");
+        System.out.println("# SQL:: " + builder.toString());
+        System.out.println("# Variables:: " + ArrayUtils.toString(getVariableNames(builder)));
+        System.out.println("# Parametros:: " + ArrayUtils.toString(getParameterNames(builder)));
+        assertEquals(
+                "",
+                builder.toString()
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(getVariableNames(builder))
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(getParameterNames(builder))
+        );
+    }
+
+
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/AbstractConnectionOperation.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/AbstractConnectionOperation.java	(revision 43113)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/AbstractConnectionOperation.java	(revision 43114)
@@ -17,6 +17,8 @@
     final static protected Logger logger = LoggerFactory.getLogger(AbstractConnectionOperation.class);
 
     final protected JDBCHelper helper;
+    
+    private Connection conn = null;
 
     public AbstractConnectionOperation(JDBCHelper helper) {
         this.helper = helper;
@@ -47,9 +49,12 @@
         }
     }
 
+    protected Connection getConnection() {
+        return this.conn;
+    }
+    
     public Object perform_operation() throws Exception {
             Object result = null;
-        Connection conn = null;
         try {
             logger.debug("preparing execution of "+this.getClass().getSimpleName()+".");
             conn = helper.getConnection();
@@ -76,6 +81,7 @@
             return result;
         } finally {
             helper.closeConnection(conn);
+            conn = null;
         }
     }
 //
